import { Document } from '../models';
export declare function getDocumentById(docId: string): Promise<Document>;
export declare function getDocumentByUrl(url: string): Promise<Document[]>;
/**
 * This method builds up a dependency graph by registering document references
 *
 * A document reference is when one document is embedding another document through
 * partial templates or by using lookup directives to use data from another document
 * inside of the current web template.
 *
 * Once any of those documents are changed, the graph needs to be traversed until
 * all rippling changes have been re-rendered.
 *
 * @param docId The ID of the document that is referring to other documents
 * @param references One or more document IDs that are being referred to in a document
 */
export declare function addDependency(docId: string, references: string | string[]): Promise<void>;
