/**
 * Creates a system message about missing index.
 *
 * Use it like this:
 *  1. Run a query that requires an index within a try/catch
 *  2. Extract the message from the exception `exception.details`
 *  3. Pass that messaage details string into this function
 *
 * The messaage details will contain a link similar to this:
 * `https://console.firebase.google.com/project/<project id>/database/firestore/indexes?create_composite=<base64 encoded data>`
 *
 * @param message Error message from Firebase SDK exception
 */
export declare function reportMissingIndex(message: string): Promise<void>;
export declare function reportUnknownError(message: string): Promise<void>;
