"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const admin = require("firebase-admin");
const siteCollection = () => admin.firestore().collection('tanam').doc(process.env.GCLOUD_PROJECT);
function getTheme() {
    return __awaiter(this, void 0, void 0, function* () {
        const siteInfo = (yield siteCollection().get()).data();
        const themeSnap = yield siteCollection().collection('themes').doc(siteInfo.theme).get();
        return themeSnap.data();
    });
}
exports.getTheme = getTheme;
function createDefaultTheme() {
    return __awaiter(this, void 0, void 0, function* () {
        const defaultTheme = {
            id: 'default',
            title: 'Default theme',
            description: 'Default site theme',
            created: admin.firestore.FieldValue.serverTimestamp(),
            updated: admin.firestore.FieldValue.serverTimestamp(),
        };
        console.log(`[createDefaultTheme] ${JSON.stringify({ defaultTheme }, null, 2)}`);
        return admin.firestore()
            .collection('tanam').doc(process.env.GCLOUD_PROJECT)
            .collection('themes').doc('default')
            .set(defaultTheme);
    });
}
exports.createDefaultTheme = createDefaultTheme;
//# sourceMappingURL=theme.service.js.map