"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const admin = require("firebase-admin");
const functions = require("firebase-functions");
exports.cleanUpDocumentsOfType = functions.firestore.document('/tanam/{siteId}/document-types/{type}').onDelete((snap, context) => __awaiter(this, void 0, void 0, function* () {
    console.log('Deleting documents..');
    const documentType = snap.data();
    const querySnaps = yield admin.firestore()
        .collection('tanam').doc(context.params.siteId)
        .collection('documents').where('documentType', '==', documentType.id)
        .get();
    const promises = [];
    for (const doc of querySnaps.docs) {
        promises.push(doc.ref.delete());
    }
    return Promise.all(promises);
}));
//# sourceMappingURL=document-type.js.map