"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const admin = require("firebase-admin");
const functions = require("firebase-functions");
exports.deleteStorageFiles = functions.firestore.document('tanam/{siteId}/files/{fileId}').onDelete((snap) => __awaiter(this, void 0, void 0, function* () {
    const file = snap.data();
    const filePrefix = file.filePath.substr(0, file.filePath.lastIndexOf('.'));
    console.log(`Delete all files starting with ${filePrefix}`);
    return admin.storage().bucket().deleteFiles({
        prefix: filePrefix,
    });
}));
exports.deleteAssetFile = functions.firestore.document('tanam/{siteId}/themes/{themeId}/assets/{assetId}').onDelete((snap) => __awaiter(this, void 0, void 0, function* () {
    const file = snap.data();
    const filePrefix = file.filePath.substr(0, file.filePath.lastIndexOf('.'));
    console.log(`Delete all asset files starting with ${filePrefix}`);
    return admin.storage().bucket().deleteFiles({
        prefix: filePrefix,
    });
}));
//# sourceMappingURL=file.js.map