"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const admin = require("firebase-admin");
const functions = require("firebase-functions");
exports.deleteTemplates = functions.firestore.document('tanam/{siteId}/themes/{themeId}').onDelete((snap) => __awaiter(this, void 0, void 0, function* () {
    console.log(`Deleting all templates for theme ${snap.data().title} (${snap.data().id})`);
    const templates = yield snap.ref.collection('templates').get();
    const promises = [];
    const batchDeletes = [];
    for (let i = 0; i < templates.docs.length; i++) {
        const doc = templates.docs[i];
        if ((i % 500) === 0) {
            batchDeletes.push(admin.firestore().batch());
        }
        const batchNum = batchDeletes.length - 1;
        console.log(`Batch delete #${batchNum} (${i + 1}/500): ${doc.id}`);
        batchDeletes[batchNum].delete(doc.ref);
    }
    batchDeletes.forEach((batchWrite) => {
        promises.push(batchWrite.commit());
    });
    return Promise.all(promises);
}));
exports.deleteAssets = functions.firestore.document('tanam/{siteId}/themes/{themeId}').onDelete((snap) => __awaiter(this, void 0, void 0, function* () {
    console.log(`Deleting all assets for theme ${snap.data().title} (${snap.data().id})`);
    const assets = yield snap.ref.collection('assets').get();
    const promises = [];
    const batchDeletes = [];
    for (let i = 0; i < assets.docs.length; i++) {
        const doc = assets.docs[i];
        if ((i % 500) === 0) {
            batchDeletes.push(admin.firestore().batch());
        }
        const batchNum = batchDeletes.length - 1;
        console.log(`Batch delete #${batchNum} (${i + 1}/500): ${doc.id}`);
        batchDeletes[batchNum].delete(doc.ref);
    }
    batchDeletes.forEach((batchWrite) => {
        promises.push(batchWrite.commit());
    });
    return Promise.all(promises);
}));
//# sourceMappingURL=theme.js.map